#ifndef LCF_POS_ENCODE_H_
#define LCF_POS_ENCODE_H_
#include "tensorOperate.h"

class PosEncodeLayer : public TensorOperate
{
    public:
        PosEncodeLayer();
        PosEncodeLayer(int ifType, int iID, int iMaxSeqNum, DevicesBatchDisptach *iDevicesBatchDisptach);
        virtual ~PosEncodeLayer();
        void SetLayerConfig(int ifType, int iID, int iMaxSeqNum, DevicesBatchDisptach *iDevicesBatchDisptach);
        void ComputeAndCreateOutYInDTensorInfo();
        void CreateParaAndInstance();
        void CompuateOutY(int devID, int seqNum);
        void CompuateOutD(int devID, int seqNum);
        void ComputerYMemRealease(int devID);
        void ComputerDMemRealease(int devID);
    private:
        void SetChildLayerMomeryPointInitStatus();
        int inChannels;
};

#endif
